/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.89 by edhill, Wed Jul 21 16:34:46 2004 UTC revision 1.98 by edhill, Tue Sep 7 21:28:47 2004 UTC
# Line 195  EOF Line 195  EOF
195              echo "    a system-default makedepend was not found."              echo "    a system-default makedepend was not found."
196                            
197              #  Try to build the cyrus implementation              #  Try to build the cyrus implementation
198              rm -f ./genmake_cy_md              build_cyrus_makedepend
             (  
                 cd $ROOTDIR/tools/cyrus-imapd-makedepend  \  
                     &&  ./configure > /dev/null 2>&1  \  
                     &&  make > /dev/null 2>&1  
                 if test -x ./makedepend.exe ; then  
                     $LN ./makedepend.exe ./makedepend  
                 fi  
                 ./makedepend ifparser.c > /dev/null 2>&1  \  
                     &&  echo "true"  
             ) > ./genmake_cy_md  
             grep true ./genmake_cy_md > /dev/null 2>&1  
199              RETVAL=$?              RETVAL=$?
200              if test "x$RETVAL" = x0 ; then              if test "x$RETVAL" != x0 ; then
                 MAKEDEPEND='$(TOOLSDIR)/cyrus-imapd-makedepend/makedepend'  
             else  
201                  MAKEDEPEND='$(TOOLSDIR)/xmakedepend'                  MAKEDEPEND='$(TOOLSDIR)/xmakedepend'
202              fi              fi
203              rm -f ./genmake_cy_md              rm -f ./genmake_cy_md
204          fi          fi
205        else
206            #  echo "MAKEDEPEND=${MAKEDEPEND}"
207            echo "${MAKEDEPEND}" | grep -i cyrus > /dev/null 2>&1
208            RETVAL=$?
209            if test x"$RETVAL" = x0 ; then
210                build_cyrus_makedepend
211            fi
212      fi      fi
213  }  }
214    
215    
216    build_cyrus_makedepend()  {
217        rm -f ./genmake_cy_md
218        (
219            cd $ROOTDIR/tools/cyrus-imapd-makedepend  \
220                &&  ./configure > /dev/null 2>&1  \
221                &&  make > /dev/null 2>&1
222            if test -x ./makedepend.exe ; then
223                $LN ./makedepend.exe ./makedepend
224            fi
225            ./makedepend ifparser.c > /dev/null 2>&1  \
226                &&  echo "true"
227        ) > ./genmake_cy_md
228        grep true ./genmake_cy_md > /dev/null 2>&1
229        RETVAL=$?
230        rm -f ./genmake_cy_md
231        if test "x$RETVAL" = x0 ; then
232            MAKEDEPEND='$(TOOLSDIR)/cyrus-imapd-makedepend/makedepend'
233            return 0
234        else
235            echo "WARNING: unable to build cyrus-imapd-makedepend"
236            return 1
237        fi
238    }
239    
240  # Guess possible config options for this host  # Guess possible config options for this host
241  find_possible_configs()  {  find_possible_configs()  {
242    
# Line 251  find_possible_configs()  { Line 269  find_possible_configs()  {
269    
270      look_for_makedepend      look_for_makedepend
271    
272      # look for possible fortran compilers      #================================================================
273        #  look for possible C compilers
274        tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc"
275        p_CC=
276        for c in $tmp ; do
277            rm -f ./genmake_hello.c  ./genmake_hello
278            cat >> genmake_hello.c << EOF
279    #include <stdio.h>
280    int main(int argc, char **argv) {
281      printf("Hello!\n");
282      return 0;
283    }
284    EOF
285            $c -o genmake_hello genmake_hello.c > /dev/null 2>&1
286            RETVAL=$?
287            if test "x${RETVAL}" = x0 ; then
288                p_CC="$p_CC $c"
289            fi
290        done
291        rm -f ./genmake_hello.c ./genmake_hello
292        if test "x${p_CC}" = x ; then
293            cat 1>&2 <<EOF
294    
295    Error: No C compilers were found in your path.  Please specify one using:
296    
297        1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),
298        2) the CC or MITGCM_CC environment variables.
299    
300    EOF
301            exit 1
302        else
303            echo "  The possible C compilers found in your path are:"
304            echo "   "$p_CC
305            if test "x$CC" = x ; then
306                CC=`echo $p_CC | $AWK '{print $1}'`
307                echo "  Setting C compiler to: "$CC
308            fi
309        fi
310    
311        #================================================================
312        #  look for possible FORTRAN compilers
313      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"
314      p_FC=      p_FC=
315      for c in $tmp ; do      for c in $tmp ; do
# Line 277  Error: No Fortran compilers were found i Line 335  Error: No Fortran compilers were found i
335    
336      1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),      1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),
337      2) a command-line option (eg. "-fc NAME"), or      2) a command-line option (eg. "-fc NAME"), or
338      3) the MITGCM_FC environment variable.      3) the FC or MITGCM_FC environment variables.
339    
340  EOF  EOF
341          exit 1          exit 1
# Line 448  Usage: "$0" [OPTIONS] Line 506  Usage: "$0" [OPTIONS]
506            will search for a working compiler by trying a list of            will search for a working compiler by trying a list of
507            "usual suspects" such as g77, f77, etc.            "usual suspects" such as g77, f77, etc.
508    
509        -cc NAME | --cc NAME | -cc=NAME | --cc=NAME
510              Use "NAME" as the C compiler.  By default, genmake
511              will search for a working compiler by trying a list of
512              "usual suspects" such as gcc, c89, cc, etc.
513    
514      -[no]ieee | --[no]ieee      -[no]ieee | --[no]ieee
515            Do or don't use IEEE numerics.  Note that this option            Do or don't use IEEE numerics.  Note that this option
516            *only* works if it is supported by the OPTFILE that            *only* works if it is supported by the OPTFILE that
# Line 457  Usage: "$0" [OPTIONS] Line 520  Usage: "$0" [OPTIONS]
520            Include MPI header files and link to MPI libraries            Include MPI header files and link to MPI libraries
521      -mpi=PATH | --mpi=PATH      -mpi=PATH | --mpi=PATH
522            Include MPI header files and link to MPI libraries using MPI_ROOT            Include MPI header files and link to MPI libraries using MPI_ROOT
523            set to PATH. i.e. Include files from $PATH/include, link to libraries            set to PATH. i.e. Include files from \$PATH/include, link to libraries
524            from $PATH/lib and use binaries from $PATH/bin.            from \$PATH/lib and use binaries from \$PATH/bin.
525    
526      -bash NAME      -bash NAME
527            Explicitly specify the Bourne or BASH shell to use            Explicitly specify the Bourne or BASH shell to use
# Line 506  WARNING: Please contact <MITgcm-support@ Line 569  WARNING: Please contact <MITgcm-support@
569  EOF  EOF
570          return 1          return 1
571      fi      fi
572      c_tcall=`nm genmake_test.o | grep 'T ' | grep tcall | cut -d ' ' -f 3`      c_tcall=`nm genmake_test.o 2>/dev/null | grep 'T ' | grep tcall | cut -d ' ' -f 3`
573      RETVAL=$?      RETVAL=$?
574      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
575          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
# Line 536  WARNING: Please contact <MITgcm-support@ Line 599  WARNING: Please contact <MITgcm-support@
599  EOF  EOF
600          return 1          return 1
601      fi      fi
602      f_tcall=`nm genmake_tcomp.o | grep 'T ' | grep tcall | cut -d ' ' -f 3`      f_tcall=`nm genmake_tcomp.o 2>/dev/null | grep 'T ' | grep tcall | cut -d ' ' -f 3`
603      RETVAL=$?      RETVAL=$?
604      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
605          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
# Line 613  EOF Line 676  EOF
676    
677    
678  check_netcdf_libs()  {  check_netcdf_libs()  {
679        echo "" > genmake_tnc.log
680      cat <<EOF > genmake_tnc.for      cat <<EOF > genmake_tnc.for
681        program fgennc        program fgennc
682  #include "netcdf.inc"  #include "netcdf.inc"
# Line 625  check_netcdf_libs()  { Line 689  check_netcdf_libs()  {
689        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
690        end        end
691  EOF  EOF
692      #echo "$CPP $DEFINES $INCLUDES"      #echo "$CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f"
693      $CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f  \      #echo "$FC $FFLAGS $FOPTIM -c genmake_tnc.f"
694          &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f $LIBS >> genmake_tnc.log 2>&1      #echo "$LINK -o genmake_tnc.o $LIBS"
695        $CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f 2>/dev/null  \
696            &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.f  \
697            &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1
698      RET_COMPILE=$?      RET_COMPILE=$?
699      test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1      test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
700      RETVAL=$?      RETVAL=$?
# Line 635  EOF Line 702  EOF
702          HAVE_NETCDF=t          HAVE_NETCDF=t
703      else      else
704          # try again with "-lnetcdf" added to the libs          # try again with "-lnetcdf" added to the libs
705          $CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f  \          $CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f 2>/dev/null  \
706              &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f \              &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f \
707              $LIBS -lnetcdf >> genmake_tnc_2.log 2>&1              $LIBS -lnetcdf >> genmake_tnc_2.log 2>&1
708          RET_COMPILE=$?          RET_COMPILE=$?
# Line 665  LN= Line 732  LN=
732  S64=  S64=
733  KPP=  KPP=
734  FC=  FC=
735    #CC=gcc
736  CPP=  CPP=
737  LINK=  LINK=
738  DEFINES=  DEFINES=
# Line 672  PACKAGES= Line 740  PACKAGES=
740  ENABLE=  ENABLE=
741  DISABLE=  DISABLE=
742  MAKEFILE=  MAKEFILE=
743  MAKEDEPEND=  #MAKEDEPEND=
744  PDEPEND=  PDEPEND=
745  DUMPSTATE=t  DUMPSTATE=t
746  PDEFAULT=  PDEFAULT=
# Line 710  BASH= Line 778  BASH=
778  PWD=`pwd`  PWD=`pwd`
779  MAKE=make  MAKE=make
780  AWK=awk  AWK=awk
781  THISHOSTNAME=`hostname`  THISHOST=`hostname`
782  THISCWD=`pwd`  THISCWD=`pwd`
783  THISDATE=`date`  THISDATE=`date`
784    THISUSER=`echo $USER`
785    THISVER=
786  MACHINE=`uname -a`  MACHINE=`uname -a`
787  EXECUTABLE=  EXECUTABLE=
788  EXEHOOK=  EXEHOOK=
# Line 746  gm_s2="FC CPP IEEE MPI JAM DUMPSTATE STA Line 816  gm_s2="FC CPP IEEE MPI JAM DUMPSTATE STA
816  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
817  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "
818  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
819  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOST THISUSER THISDATE THISVER MACHINE"
820  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
821  gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE HAVE_ETIME"  gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE HAVE_ETIME"
822    
# Line 895  for ac_option in $@ ; do Line 965  for ac_option in $@ ; do
965  #               ac_prev=cpp ;;  #               ac_prev=cpp ;;
966  #           -cpp=* | --cpp=*)  #           -cpp=* | --cpp=*)
967  #               CPP=$ac_optarg ;;  #               CPP=$ac_optarg ;;
968                        
969            -cc | --cc)
970                ac_prev=CC ;;
971            -cc=* | --cc=*)
972                CC=$ac_optarg ;;
973            
974          -fortran | --fortran | -fc | --fc)          -fortran | --fortran | -fc | --fc)
975              ac_prev=FC ;;              ac_prev=FC ;;
976          -fc=* | --fc=*)          -fc=* | --fc=*)
# Line 966  if test -f ./.genmakerc ; then Line 1041  if test -f ./.genmakerc ; then
1041      echo      echo
1042  fi  fi
1043    
1044    #  Find the MITgcm ${ROOTDIR}
1045  if test "x${ROOTDIR}" = x ; then  if test "x${ROOTDIR}" = x ; then
1046      tmp=`echo $PWD | sed -e 's/\// /g' | awk '{print $NR}'`      tmp=`echo $PWD | sed -e 's/\// /g' | awk '{print $NR}'`
1047      if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then      if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then
# Line 992  if test ! -d ${ROOTDIR} ; then Line 1068  if test ! -d ${ROOTDIR} ; then
1068      exit 1      exit 1
1069  fi  fi
1070    
1071    #  Find the MITgcm ${THISVER}
1072    if test -f "${ROOTDIR}/doc/tag-index" ; then
1073        THISVER=`grep checkpoint ${ROOTDIR}/doc/tag-index | head -1`
1074    fi
1075    
1076  echo "  getting OPTFILE information:  "  echo "  getting OPTFILE information:  "
1077  if test "x${OPTFILE}" = x ; then  if test "x${OPTFILE}" = x ; then
1078      if test "x$MITGCM_OF" = x ; then      if test "x$MITGCM_OF" = x ; then
# Line 1051  if test "x${AD_OPTFILE}" != xNONE ; then Line 1132  if test "x${AD_OPTFILE}" != xNONE ; then
1132      fi      fi
1133  fi  fi
1134    
1135  #  Check that FC, LINK, CPP, S64, LN, and MAKE are defined.  If not,  #  Check that FC, CC, LINK, CPP, S64, LN, and MAKE are defined.  If not,
1136  #  either set defaults or complain and abort!  #  either set defaults or complain and abort!
1137  if test ! "x$BASH" = x ; then  if test ! "x$BASH" = x ; then
1138      # add a trailing space so that it works within the Makefile syntax (see below)      # add a trailing space so that it works within the Makefile syntax (see below)
# Line 1067  Error: no Fortran compiler: please speci Line 1148  Error: no Fortran compiler: please speci
1148  EOF  EOF
1149      exit 1      exit 1
1150  fi  fi
1151    if test "x$CC" = x ; then
1152        CC=cc
1153    #     cat <<EOF 1>&2
1154    # Error: no C compiler: please specify using one of the following:
1155    #   1) within the options file ("CC=...") as specified by "-of=OPTFILE"
1156    #   2) the "-cc=XXX" command-line option
1157    #   3) the "./genmake_local" file
1158    # EOF
1159    #     exit 1
1160    fi
1161  if test "x$LINK" = x ; then  if test "x$LINK" = x ; then
1162      LINK=$FC      LINK=$FC
1163  fi  fi
# Line 1652  for d in $alldirs ; do Line 1743  for d in $alldirs ; do
1743                          ;;                          ;;
1744                    ./FC_NAMEMANGLE.h)                    ./FC_NAMEMANGLE.h)
1745                          ;;                          ;;
1746                      ./BUILD_INFO.h)
1747                            ;;
1748                    *)                    *)
1749                          touch .links.tmp/$sf                          touch .links.tmp/$sf
1750                          deplist="$deplist $sf"                          deplist="$deplist $sf"
# Line 1708  echo "#    $THISDATE" >> $MAKEFILE Line 1801  echo "#    $THISDATE" >> $MAKEFILE
1801  echo "# by the command:" >> $MAKEFILE  echo "# by the command:" >> $MAKEFILE
1802  echo "#    $0 $G2ARGS" >> $MAKEFILE  echo "#    $0 $G2ARGS" >> $MAKEFILE
1803  echo "# executed by:" >> $MAKEFILE  echo "# executed by:" >> $MAKEFILE
1804  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE  echo "#    ${THISUSER}@${THISHOST}:${THISCWD}" >> $MAKEFILE
1805    
1806  EXE_AD=$EXECUTABLE"_ad"  EXE_AD=$EXECUTABLE"_ad"
1807  EXE_FTL=$EXECUTABLE"_ftl"  EXE_FTL=$EXECUTABLE"_ftl"
# Line 1754  ENABLED_PACKAGES = ${ENABLED_PACKAGES} Line 1847  ENABLED_PACKAGES = ${ENABLED_PACKAGES}
1847  DISABLED_PACKAGES = ${DISABLED_PACKAGES}  DISABLED_PACKAGES = ${DISABLED_PACKAGES}
1848    
1849  # These files are created by Makefile  # These files are created by Makefile
1850  SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h  SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h BUILD_INFO.h
1851    
1852  EOF  EOF
1853    
# Line 1773  KPP = ${KPP} Line 1866  KPP = ${KPP}
1866  FC = ${FC}  FC = ${FC}
1867  # Fortran compiler  # Fortran compiler
1868  F90C = ${F90C}  F90C = ${F90C}
1869    # C compiler
1870    CC = ${CC}
1871  # Link editor  # Link editor
1872  LINK = ${LINK} ${LDADD}  LINK = ${LINK} ${LDADD}
1873    
# Line 1856  makefile: Line 1951  makefile:
1951  cleanlinks:  cleanlinks:
1952          -find . -type l -exec rm {} \;          -find . -type l -exec rm {} \;
1953    
1954  # Special targets ($SPECIAL_FILES) which are create by make  # Special targets (SPECIAL_FILES) which are create by make
1955  ${PACKAGES_DOT_H}:  ${PACKAGES_DOT_H}:
1956          @echo Creating \$@ ...          @echo Creating \$@ ...
1957          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@
# Line 1867  FC_NAMEMANGLE.h: Line 1962  FC_NAMEMANGLE.h:
1962          @echo Creating \$@ ...          @echo Creating \$@ ...
1963          echo "$FC_NAMEMANGLE" > \$@          echo "$FC_NAMEMANGLE" > \$@
1964    
1965    BUILD_INFO.h:
1966            @echo Creating \$@ ...
1967    EOF
1968    
1969    test ! "x$THISVER" = x  && echo "       -echo \"#define THISVER '$THISVER'\" > \$@"   >> $MAKEFILE
1970    test ! "x$THISUSER" = x && echo "       -echo \"#define THISUSER '$THISUSER'\" >> \$@" >> $MAKEFILE
1971    test ! "x$THISDATE" = x && echo "       -echo \"#define THISDATE '$THISDATE'\" >> \$@" >> $MAKEFILE
1972    test ! "x$THISHOST" = x && echo "       -echo \"#define THISHOST '$THISHOST'\" >> \$@" >> $MAKEFILE
1973    
1974    cat >>$MAKEFILE <<EOF
1975    
1976  # The normal chain of rules is (  .F - .$FS - .o  )  # The normal chain of rules is (  .F - .$FS - .o  )
1977    
1978  %.o : %.F  %.o : %.F

Legend:
Removed from v.1.89  
changed lines
  Added in v.1.98

  ViewVC Help
Powered by ViewVC 1.1.22